; ---------------------------------------------------
; INTERRUPCIO 8 : CAPTURADOR DE MOSTRES EN TEMPS REAL
; ---------------------------------------------------
; ACME ANALYZER. PER A. J. ANTON

        extrn _is_signal : word
        extrn _overrun   : word         ; pasant olimpicament d'ella
        extrn _captador  : word
        extrn _mostres   : word
        extrn _entrada
        extrn _slope     : word
        extrn _trigger   : word

        public _capturador

_text   segment para public 'CODE'
        assume cs:_text

contador dw 1

_capturador proc far
        push ax
        push bx
        push cx
        push dx
        push si
        push ds                         ; preserva registres

        mov ax,SEG _is_signal
        mov ds,ax
        cmp word ptr [_is_signal],0     ; si is_signal == TRUE
        jz cont                         ; no fa res
        jmp final

cont:   mov ax,SEG _captador
        mov ds,ax
        mov bx,[_captador]              ; bx = captador

        mov ax,SEG _entrada
        mov ds,ax
        mov dx,[_entrada]
        mov ax,[_entrada+2]
        mov ds,ax
        mov ax,dx                       ; ds:ax = entrada[]
        
        mov si,cs:[contador]            ; si = mostra actual
        rol si,1                        ; si *= 2 -> si = offset a mostra

        cmp bx,1
        jz lpt1                         ; entrada lpt1
        cmp bx,2
        jz sb                           ; entrada sound blaster
        cmp bx,3
        jz intr81                       ; entrada INT 81h
        cmp bx,4
        jz expr                         ; entrada generador d'expresions
        
expr:
nula:   mov bx,ax
        mov word ptr [bx+si],0          ; entrada[contador] = 0
        jmp conta

lpt1:   mov bx,ax                       ; en bx la @ on escriure
        mov dx,37Ah
        mov al,8
        out dx,al                       ; !WR = 0
        dec dx
        dec dx
        out dx,al                       ; acces a 4 bits baixos
        inc dx
        in al,dx                        ; llegim 4 bits baixos
        mov ah,al
        and al,038h                     ; AL and 0011 1000
        and ah,080h                     ; AH and 1000 0000
        xor ah,080h                     ; complementa'l
        shr ah,1                        ; mou-lo 1 bit a la dreta
        or al,ah                        ; junta amb els anteriors
        mov cl,3
        shr al,cl                       ; posa-ho tot baix
        mov ch,al                       ; preserva-ho en ch
        dec dx
        mov al,1                        ; acces a bits alts
        out dx,al
        inc dx
        in al,dx                        ; llegeix bits alts
        mov ah,al
        and al,038h                     ; AL and 0011 1000
        and ah,080h                     ; AH and 1000 0000
        xor ah,080h                     ; complementa'l
        shr ah,1                        ; mou-lo 1 bit a la dreta
        or al,ah                        ; junta amb els anteriors
        sal al,1                        ; posa-ho tot dalt
        or al,ch                        ; junta-ho amb els bits baixos
        xor ah,ah                       ; els 8 bits de dalt a 0
        mov [bx+si],ax                  ; escriu en memoria
        inc dx
        xor al,al
        out dx,al                       ; !WR=1 -> inicia seguent conversio
        jmp conta
        
intr81: mov bx,ax
        mov ax,1
        int 81h                         ; genera INT 81h amb AX=1
        mov [bx+si],ax                  ; entrada[contador] = AX
        jmp conta

sb:     mov bx,ax
        mov dx,22ch
wait1:  in al,dx
        and al,80h
        jnz wait1                       ; espera que bit 7 de in(22ch) == 0
        mov al,20h
        out dx,al                       ; out(22ch, 20h)
        mov dx,22eh
wait2:  in al,dx
        and al,80h
        jz wait2                        ; espera que bit 7 de in(22e) == 1
        mov dx,22ah
        in al,dx                        ; al es la entrada des de s.b.
        xor ah,ah
        sub ax,128                      ; ax = ax - 128
        mov [bx+si],ax                  ; entrada[contador] = ax

conta:  inc cs:[contador]               ; contador++
        mov si,cs:[contador]
        mov ax,SEG _mostres
        mov ds,ax
        cmp si,[_mostres]               ; Si si >= mostres -> vector complet
        jge complet
        jmp final
complet:mov word ptr cs:[contador],1    ; contador = 1
        mov ax,SEG _is_signal
        mov ds,ax
        mov word ptr [_is_signal],1     ; is_signal = TRUE

stop:   mov al,30h                      ; para el timer0
        out 43h,al
        xor al,al
        out 40h,al
        out 40h,al
        
final:  pop ds                          ; recupera registres
        pop si
        pop dx
        pop cx
        pop bx
        mov al,20h
        out 20h,al                      ; EOI
        pop ax

        iret
_capturador endp

_text   ends
        end
